=== debian/changelog ===
librdkafka (1.8.0-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 16:01:50 +0100

librdkafka (1.8.0-1) unstable; urgency=medium

  [ Faidon Liambotis ]
  * Add pristine-tar=True to gbp.conf

  [ ChangZhuo Chen (陳昌倬) ]
  * New upstream release.
  * Bump Standards-Version to 4.6.0.
  * Update symbol file.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 19 Sep 2021 14:39:58 +0800
