=== debian/tests/control ===
Tests: examples
Depends: librdkafka-dev, build-essential, pkg-config
Restrictions: allow-stderr

Tests: unittest
Depends: librdkafka-dev, build-essential, pkg-config
Restrictions: allow-stderr
