=== debian/watch ===
version=4
https://github.com/edenhill/librdkafka/tags .*/v?(\d[\d\.]*)\.tar\.gz
