=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  python3,
  rapidjson-dev,
  zlib1g-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://github.com/edenhill/librdkafka
