=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -117,6 +117,18 @@
     0123-connections_max_idle.c
     0124-openssl_invalid_engine.c
     0125-immediate_flush.c
+    0126-oauthbearer_oidc.c
+    0128-sasl_callback_queue.cpp
+    0129-fetch_aborted_msgs.c
+    0130-store_offsets.c
+    0131-connect_timeout.c
+    0132-strategy_ordering.c
+    0133-ssl_keys.c
+    0134-ssl_provider.c
+    0135-sasl_credentials.cpp
+    0136-resolve_cb.c
+    0137-barrier_batch_consume.c
+    0138-admin_mock.c
     8000-idle.cpp
     test.c
     testcpp.cpp
