=== tests/requirements.txt ===
trivup >= 0.12.1
jsoncomment
