=== debian/changelog ===
librdkafka (2.0.2-1) unstable; urgency=medium

  * New upstream release.
    - Update librdkafka1.symbols to add new (2.0.0) symbols.

 -- Faidon Liambotis <paravoid@debian.org>  Thu, 09 Feb 2023 04:22:10 +0200
