=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Section: libs
-Homepage: https://github.com/edenhill/librdkafka
+Homepage: https://github.com/confluentinc/librdkafka
 Vcs-Git: https://salsa.debian.org/kafka-team/librdkafka.git
 Vcs-Browser: https://salsa.debian.org/kafka-team/librdkafka
